
#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include "../SmartSlog_lib/drinkers.h"

int main()
{
   
    sslog_ss_init_session_with_parameters("X", "194.85.173.9", 10010);
  //   sslog_ss_init_session_with_parameters("X", "137.204.143.19", 10010); 
	register_ontology();

    if (ss_join(sslog_get_ss_info(), "KP Timo") == -1) {
        printf("Can't join to SS\n");
        return 0;
    }

    printf("\n\n --- Timo's agent have joined to SS --- \n\n\n");
    printf("Initialization of structures...\t\t\t");

    individual_t *timo = sslog_new_individual(CLASS_MAN);

    sslog_add_property(timo, PROPERTY_FNAME, "Timo");
    sslog_add_property(timo, PROPERTY_LNAME, "Ericsson");

    sslog_set_individual_uuid(timo, "timo");
 
    sslog_ss_insert_individual(timo);
 
    individual_t *sms = sslog_new_individual(CLASS_SMS);
	sslog_set_individual_uuid(sms, "sms");

    sslog_add_property(sms, PROPERTY_TO, "87236482");

    subscription_t *subscription = sslog_new_subscription(true);
    if (subscription == NULL) {
	    printf("conatiner is null");
	    exit (0);
    }
    printf("done\n");

	printf("Subscribing to SMS...\t\t\t\t");
	
    list_t *properties = list_get_new_list();
    list_add_data(PROPERTY_TO, properties);
    list_add_data(PROPERTY_FROM, properties);

    sslog_sbcr_add_individual(subscription, sms, properties);

    if (sslog_sbcr_subscribe(subscription) != 0) {
	    printf("\nCan't subscribe\n");
	    sslog_free_subscription(subscription);
	    sslog_ss_leave_session(sslog_get_ss_info());
	    return 0;
    }
	printf("done\n");

	char liters[2] = {'0', '\0'};

    char c;
	printf("\n\n --- Press any key to continue --- \n\n");
	c = (char) getc(stdin);

	sslog_ss_add_property(timo, PROPERTY_DRINKS, "beer");
	sslog_ss_add_property(timo, PROPERTY_NUMBER_OF_DRINKS, liters);

    while (true) {
		char *old_val = strdup(liters);

		const prop_val_t *p_val = sslog_get_property(sms, PROPERTY_FROM->name);
		if (p_val != NULL && p_val->prop_value != NULL && strcmp(p_val->prop_value, "732468") == 0) {
            sslog_ss_remove_property_by_name_all(sms, PROPERTY_FROM->name);
			printf("\n\n -!-!- Incoming SMS from 732468 -!-!-\n\n");
			sleep(1);
			printf("\n\n --- Timo have stoped drinking --- \n");
            free(old_val);
			break;
		}

		++liters[0];
		printf("Timo drinks\t%s liters\n", liters);
		if (liters[0] == '5') {
            free(old_val);
            break;
        }

		if (sslog_ss_update_property(timo, PROPERTY_NUMBER_OF_DRINKS->name, old_val, liters) < 0)
			printf("\n\n ------- Values coudn't be updated: %s\n", get_error_text());
		free(old_val);

	    sleep(3);
	}

	sslog_ss_remove_property_by_name_all(timo, PROPERTY_DRINKS->name);

    sslog_sbcr_unsubscribe_all(true);

	sslog_ss_leave_session_all();

    sslog_repo_clean_all();

    printf("\n\nTimo's agent leave SS...\n");

    return 0;
}
