#define NO_INDIVIDUALS 123
#include "../SmartSlog_lib/drinkers.h"

#include <stdio.h>
#include <smartslog/subscription.h>
#include <unistd.h>
#include <string.h>

int main()
{
    sslog_ss_init_new_session_with_parameters("X", "127.0.0.1", 10010, "Home");
    if (ss_join(sslog_get_ss_info(), "KP Wife") == -1) {
        printf("Can't join to Home\n");
        return 0;
    }

    sslog_ss_init_new_session_with_parameters("X", "194.85.173.9", 10012, "Bar");
    if (ss_join(sslog_get_ss_info(), "KP Wife") == -1) {
        printf("Can't join to Bar\n");
        return 0;
    }

    register_ontology();

    sslog_switch_sib("Home");

    printf("\n\n --- Wife's agent have joined to SS --- \n\n\n");
    printf("Initialization of structures...\t\t\t");

    pattern_t *pattern = sslog_new_pattern(CLASS_MAN, NULL);
    individual_t *timo;

    sslog_add_property_to_pattern(pattern, PROPERTY_FNAME, "Timo", PATTERN_COND_NO);
    sslog_add_property_to_pattern(pattern, PROPERTY_LNAME, "Ericsson", PATTERN_COND_NO);

    list_t *timos = sslog_ss_get_individual_by_pattern_all(pattern);
    if (timos == NULL) {
        sslog_ss_leave_session(sslog_get_ss_info());
        printf("There are no such individuals");
        return NO_INDIVIDUALS;
    }
    list_head_t *pos = NULL;

    list_for_each(pos, &timos->links)
    {
        list_t *node = list_entry(pos, list_t, links);
        timo = (individual_t *) node->data;
        break;
    }
    printf("done\n");

    sslog_switch_sib("Bar");

    printf("Subscribing to beer...\t\t\t\t");
    subscription_t *subscription = sslog_new_subscription(false);

    list_t *properties = list_get_new_list();
    list_add_data(PROPERTY_DRINKS, properties);

    sslog_sbcr_add_individual(subscription, timo, properties);

    if (sslog_sbcr_subscribe(subscription) != 0) {
        printf("\nCan't subscribe\n");
        sslog_free_subscription(subscription);
        sslog_ss_leave_session(sslog_get_ss_info());
        return 0;
    }
    printf("done\n");

    char c;
    printf("\n\n --- Press any key to continue --- \n\n");
    c = (char) getc(stdin);

    int sms_sended = 0;
    while (true) {
        const prop_val_t *p_val = sslog_get_property(timo, PROPERTY_DRINKS->name);

        if (!sms_sended && p_val != NULL && strcmp(p_val->prop_value, "beer") == 0) {
            printf("\n\n --- Timo starts drinking --- \n\n");
            printf("Subscribing to number of liters...\t\t\t");
            subscription_t *conatiner2 = sslog_new_subscription(false);

            list_t *properties2 = list_get_new_list();
            list_add_data(PROPERTY_NUMBER_OF_DRINKS, properties2);

            sslog_sbcr_add_individual(conatiner2, timo, properties2);

            if (sslog_sbcr_subscribe(conatiner2) != 0) {
                printf("\nCan't subscribe\n");
                sslog_free_subscription(conatiner2);
                sslog_ss_leave_session(sslog_get_ss_info());
                return 0;
            }
            printf("done\n");

            while (true) {
                const prop_val_t *p_val2 = sslog_get_property(timo, PROPERTY_NUMBER_OF_DRINKS->name);
                printf("Timo drinks\t%s liters\n", (char *) p_val2->prop_value);

                if (p_val2 != NULL && strcmp(p_val2->prop_value, "3") == 0) {
                    sslog_switch_sib("Home");
                    printf("\nSending SMS ... \t\t\t\t");
                    individual_t *sms = sslog_new_individual(CLASS_SMS);
                    sslog_set_individual_uuid(sms, "sms");

                    sslog_add_property(sms, PROPERTY_TO, "87236482");
                    sslog_add_property(sms, PROPERTY_FROM, "732468");

                    sslog_ss_insert_individual(sms);
                    printf("done\n");

                    sms_sended = 1;

                    break;
                }

                sslog_sbcr_wait(conatiner2);
            }

        } else if (sms_sended && p_val == NULL) {
            printf("\n\nWait Timo at home :)\n");
            break;
        } else {
            printf("\n\nWait, Timo haven't starts drunk yet\n");
        }
        if (sms_sended) break;

        sslog_sbcr_wait(subscription);
    }

    sslog_sbcr_unsubscribe_all(true);

    sslog_ss_leave_session_all();

    printf("\nKP leave SS...\n");

    sslog_repo_clean_all();

    return 0;
}
