// File contains generai information. It is used for doxygen only.

/**
 * @mainpage SmartSlog KP Library (version 0.41alpha)
 *
 * @section DESCRIPTION
 *
 * SmartSlog is a multilingual ontology library generator for
 * the Smart-M3 platform (http://sourceforge.net/projects/smart-m3/).
 * The generator maps an OWL ontology description
 * to final code (ontology library).
 * Recent version supports ontology libraries for ANSI C and .Net(C#).
 * The library provides API for programming Smart-M3 knowledge processors
 * (KP or agents) in high-level terms of ontology entities
 * (classes, properties, individuals) instead of low-level triplet-based terms.
 *
 * From KP programmer's point of view: Given an ontology description,
 * SmartSlog provides the corresponding ontology library that implements
 * data structures for representing in a KP program the ontology classes,
 * relations, properties, and individuals as well as generic API for
 * communicating with a Smart-M3 Semantic Information Broker (SIB).
 *
 * A SmartSlog ontology library is between KP application and a low-level
 * library (KP Interface, KPI). The latter directly accesses a Smart-M3 SIB
 * using SSAP protocol.
 *
 * SmartSlog KP libraryry for ANSI-C: An ontology-unaware part of the library
 * for ANSI C. This library and its dependencies can be installed as .a and .so
 * libraries in a Linux environment. The code should be also compatible with a
 * standard C++ complier and Qt/C++ application code development.
 *
 * <b>Project page:</b> http://sourceforge.net/projects/smartslog/
 *
 * <br />
 *
 * The project is done by FRUCT Lab at the IT-park of
 * Petrozavodsk State University (PetrSU), Russia.
 * The development started in 2009.
 *
 * <b>Project owner:</b> Sergey I. Balandin, PhD, Adjunct Professor,
 * General Chair Open Innovations Program FRUCT.<br />
 * <b>Head of PetrSU FRUCT Lab:</b> Iurii A. Bogoiavlenskii, PhD,
 * Head of Department of Computer Science, PetrSU.<br />
 * <b>Adviser and project leader:</b> Dmitry G. Korzun, PhD,
 * Adjunct Professor. <br>
 * <b>Developers:</b>  Aleksandr A. Lomov (2009),
 * Pavel I. Vanag (2009), Sergey Marchenkov (2011)
 *
 * <b>Mail-list:</b> smartslog@cs.karelia.ru
 *
 * <br />
 *
 * @section LICENSE
 *
 * SmartSlog KP Library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SmartSlog KP Library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SmartSlog KP Library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 *
 * <b>Copyright 2009-2012 (C) SmartSlog Team.
 * All rights reserved.</b> <br />
 */

#ifndef DESCRIPTION_H
#define	DESCRIPTION_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* DESCRIPTION_H */

